/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id : $ 
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.engine.eip;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map.Entry;

import javax.xml.namespace.NamespaceContext;

/**
 * @version $Rev: $ $Date: $
 * @author Guillaume Decarnin - Open Wide
 */
public class CustomNamespaceContext implements NamespaceContext {
    
    private HashMap<String, String> mapUri = null;
    private HashMap<String, String> mapPrefix = null;

    /**
     * Namespace with one URI.
     * @param prefix
     * @param uri
     */
    public CustomNamespaceContext(String prefix, String uri) {
        this.mapUri = new HashMap<String, String>();
        this.mapUri.put(prefix, uri);

        // reverted map
        this.mapPrefix = new HashMap<String, String>();
        this.mapPrefix.put(uri, prefix);
    }
    
    /**
     * @param mapUri key = prefix ; value = namespaceURI
     */
    public CustomNamespaceContext(HashMap<String, String> mapUri) {
        this.mapUri = mapUri;
        
        // reverted map
        this.mapPrefix = new HashMap<String, String>();
        for (Entry<String, String> entry : mapUri.entrySet()) {
            mapPrefix.put(entry.getValue(), entry.getKey());
        }
    }

    public String getNamespaceURI(String prefix) {
        return mapUri.get(prefix);
    }

    public String getPrefix(String namespaceURI) {
       return mapPrefix.get(namespaceURI);
    }

    public Iterator<String> getPrefixes(String namespaceURI) {
        return mapPrefix.values().iterator();
    }
}
